IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GOP_ITEMORCAOP' AND
                 TYPE   = 'TR'                AND
                 U.UID  = O.UID               AND
                 U.NAME = USER)
DROP TRIGGER LOG_GOP_ITEMORCAOP
GO

CREATE TRIGGER LOG_GOP_ITEMORCAOP
ON ITEMORCAOP
FOR DELETE, INSERT, UPDATE
AS

   DECLARE @V_USUARIO        VARCHAR(40);
   DECLARE @V_TIPO           VARCHAR(1);
   DECLARE @V_ITPESQ         VARCHAR(40);
   DECLARE @V_DESC           VARCHAR(300);
   DECLARE @V_DTOPER         DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO          VARCHAR(1);

   DECLARE @V_OLD_NRANOORCAOP     VARCHAR(4);
   DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE @V_OLD_NRSEQITEMORCA   VARCHAR(10);
   DECLARE @V_OLD_CDVERSORCAOP    NUMERIC;
   DECLARE @V_OLD_IDENTRSAIDOP    VARCHAR(1);
   DECLARE @V_OLD_CDTIPOOPER      VARCHAR(2);
   DECLARE @V_OLD_CDDESPADMFAT    VARCHAR(2);
   DECLARE @V_OLD_CDDESPPREV      VARCHAR(3);
   DECLARE @V_OLD_DTORCAMENTOITEM DATETIME;
   DECLARE @V_OLD_DTMESBASEITEM   DATETIME;
   DECLARE @V_OLD_IDTIPOORCAOP    VARCHAR(1);
   DECLARE @V_OLD_VRORCAMENTOJAN  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOFEV  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOMAR  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOABR  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOMAI  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOJUN  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOJUL  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOAGO  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOSET  FLOAT;
   DECLARE @V_OLD_VRORCAMENTOOUT  FLOAT;
   DECLARE @V_OLD_VRORCAMENTONOV  FLOAT;
   DECLARE @V_OLD_VRORCAMENTODEZ  FLOAT;
   DECLARE @V_OLD_IDITEMORCAMENTO VARCHAR(1);
   DECLARE @V_OLD_CDSERVFILI      VARCHAR(5);
   

   DECLARE @V_NEW_NRANOORCAOP     VARCHAR(4);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE @V_NEW_NRSEQITEMORCA   VARCHAR(10);
   DECLARE @V_NEW_CDVERSORCAOP    NUMERIC;
   DECLARE @V_NEW_IDENTRSAIDOP    VARCHAR(1);
   DECLARE @V_NEW_CDTIPOOPER      VARCHAR(2);
   DECLARE @V_NEW_CDDESPADMFAT    VARCHAR(2);
   DECLARE @V_NEW_CDDESPPREV      VARCHAR(3);
   DECLARE @V_NEW_DTORCAMENTOITEM DATETIME;
   DECLARE @V_NEW_DTMESBASEITEM   DATETIME;
   DECLARE @V_NEW_IDTIPOORCAOP    VARCHAR(1);
   DECLARE @V_NEW_VRORCAMENTOJAN  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOFEV  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOMAR  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOABR  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOMAI  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOJUN  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOJUL  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOAGO  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOSET  FLOAT;
   DECLARE @V_NEW_VRORCAMENTOOUT  FLOAT;
   DECLARE @V_NEW_VRORCAMENTONOV  FLOAT;
   DECLARE @V_NEW_VRORCAMENTODEZ  FLOAT;
   DECLARE @V_NEW_IDITEMORCAMENTO VARCHAR(1);
   DECLARE @V_NEW_CDSERVFILI      VARCHAR(5);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NRANOORCAOP,
         CDFILIAL,
         NRSEQITEMORCA,
         CDVERSORCAOP,
         IDENTRSAIDOP,
         CDTIPOOPER,
         CDDESPADMFAT,
         CDDESPPREV,
         DTORCAMENTOITEM,
         DTMESBASEITEM,
         IDTIPOORCAOP,
		 VRORCAMENTOJAN,
		 VRORCAMENTOFEV,
		 VRORCAMENTOMAR,
		 VRORCAMENTOABR,
		 VRORCAMENTOMAI,
		 VRORCAMENTOJUN,
		 VRORCAMENTOJUL,
		 VRORCAMENTOAGO,
		 VRORCAMENTOSET,
		 VRORCAMENTOOUT,
		 VRORCAMENTONOV,
		 VRORCAMENTODEZ,
		 IDITEMORCAMENTO,
		 CDSERVFILI,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         DELETED
      WHERE
         NRANOORCAOP+CDFILIAL+NRSEQITEMORCA+CDVERSORCAOP NOT IN (SELECT NRANOORCAOP+CDFILIAL+NRSEQITEMORCA+CDVERSORCAOP FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.NRANOORCAOP,
         DELETED.CDFILIAL,
         DELETED.NRSEQITEMORCA,
         DELETED.CDVERSORCAOP,
         DELETED.IDENTRSAIDOP,
         DELETED.CDTIPOOPER,
         DELETED.CDDESPADMFAT,
         DELETED.CDDESPPREV,
         DELETED.DTORCAMENTOITEM,
         DELETED.DTMESBASEITEM,
         DELETED.IDTIPOORCAOP,
		 DELETED.VRORCAMENTOJAN,
		 DELETED.VRORCAMENTOFEV,
		 DELETED.VRORCAMENTOMAR,
		 DELETED.VRORCAMENTOABR,
		 DELETED.VRORCAMENTOMAI,
		 DELETED.VRORCAMENTOJUN,
		 DELETED.VRORCAMENTOJUL,
		 DELETED.VRORCAMENTOAGO,
		 DELETED.VRORCAMENTOSET,
		 DELETED.VRORCAMENTOOUT,
		 DELETED.VRORCAMENTONOV,
		 DELETED.VRORCAMENTODEZ,
		 DELETED.IDITEMORCAMENTO,
		 DELETED.CDSERVFILI,
         INSERTED.NRANOORCAOP,
         INSERTED.CDFILIAL,
         INSERTED.NRSEQITEMORCA,
         INSERTED.CDVERSORCAOP,
         INSERTED.IDENTRSAIDOP,
         INSERTED.CDTIPOOPER,
         INSERTED.CDDESPADMFAT,
         INSERTED.CDDESPPREV,
         INSERTED.DTORCAMENTOITEM,
         INSERTED.DTMESBASEITEM,
         INSERTED.IDTIPOORCAOP,
		 INSERTED.VRORCAMENTOJAN,
		 INSERTED.VRORCAMENTOFEV,
		 INSERTED.VRORCAMENTOMAR,
		 INSERTED.VRORCAMENTOABR,
		 INSERTED.VRORCAMENTOMAI,
		 INSERTED.VRORCAMENTOJUN,
		 INSERTED.VRORCAMENTOJUL,
		 INSERTED.VRORCAMENTOAGO,
		 INSERTED.VRORCAMENTOSET,
		 INSERTED.VRORCAMENTOOUT,
		 INSERTED.VRORCAMENTONOV,
		 INSERTED.VRORCAMENTODEZ,
		 INSERTED.IDITEMORCAMENTO,
		 INSERTED.CDSERVFILI
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRANOORCAOP  = DELETED.NRANOORCAOP    AND
         INSERTED.CDFILIAL = DELETED.CDFILIAL           AND
         INSERTED.NRSEQITEMORCA = DELETED.NRSEQITEMORCA AND
         INSERTED.CDVERSORCAOP = DELETED.CDVERSORCAOP 

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NRANOORCAOP,
         CDFILIAL,
         NRSEQITEMORCA,
         CDVERSORCAOP,
         IDENTRSAIDOP,
         CDTIPOOPER,
         CDDESPADMFAT,
         CDDESPPREV,
         DTORCAMENTOITEM,
         DTMESBASEITEM,
         IDTIPOORCAOP,
		 VRORCAMENTOJAN,
		 VRORCAMENTOFEV,
		 VRORCAMENTOMAR,
		 VRORCAMENTOABR,
		 VRORCAMENTOMAI,
		 VRORCAMENTOJUN,
		 VRORCAMENTOJUL,
		 VRORCAMENTOAGO,
		 VRORCAMENTOSET,
		 VRORCAMENTOOUT,
		 VRORCAMENTONOV,
		 VRORCAMENTODEZ,
		 IDITEMORCAMENTO,
		 CDSERVFILI
      FROM
         INSERTED
      WHERE
         NRANOORCAOP+CDFILIAL+NRSEQITEMORCA+CDVERSORCAOP NOT IN (SELECT NRANOORCAOP+CDFILIAL+NRSEQITEMORCA+CDVERSORCAOP FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
									@V_OLD_NRANOORCAOP,
									@V_OLD_CDFILIAL,
									@V_OLD_NRSEQITEMORCA,
									@V_OLD_CDVERSORCAOP,
									@V_OLD_IDENTRSAIDOP,
									@V_OLD_CDTIPOOPER,
									@V_OLD_CDDESPADMFAT,
									@V_OLD_CDDESPPREV,
									@V_OLD_DTORCAMENTOITEM,
									@V_OLD_DTMESBASEITEM,
									@V_OLD_IDTIPOORCAOP,
									@V_OLD_VRORCAMENTOJAN,
									@V_OLD_VRORCAMENTOFEV,
									@V_OLD_VRORCAMENTOMAR,
									@V_OLD_VRORCAMENTOABR,
									@V_OLD_VRORCAMENTOMAI,
									@V_OLD_VRORCAMENTOJUN,
									@V_OLD_VRORCAMENTOJUL,
									@V_OLD_VRORCAMENTOAGO,
									@V_OLD_VRORCAMENTOSET,
									@V_OLD_VRORCAMENTOOUT,
									@V_OLD_VRORCAMENTONOV,
									@V_OLD_VRORCAMENTODEZ,
									@V_OLD_IDITEMORCAMENTO,
									@V_OLD_CDSERVFILI,

									@V_NEW_NRANOORCAOP,
									@V_NEW_CDFILIAL,
									@V_NEW_NRSEQITEMORCA,
									@V_NEW_CDVERSORCAOP,
									@V_NEW_IDENTRSAIDOP,
									@V_NEW_CDTIPOOPER,
									@V_NEW_CDDESPADMFAT,
									@V_NEW_CDDESPPREV,
									@V_NEW_DTORCAMENTOITEM,
									@V_NEW_DTMESBASEITEM,
									@V_NEW_IDTIPOORCAOP,
									@V_NEW_VRORCAMENTOJAN,
									@V_NEW_VRORCAMENTOFEV,
									@V_NEW_VRORCAMENTOMAR,
									@V_NEW_VRORCAMENTOABR,
									@V_NEW_VRORCAMENTOMAI,
									@V_NEW_VRORCAMENTOJUN,
									@V_NEW_VRORCAMENTOJUL,
									@V_NEW_VRORCAMENTOAGO,
									@V_NEW_VRORCAMENTOSET,
									@V_NEW_VRORCAMENTOOUT,
									@V_NEW_VRORCAMENTONOV,
									@V_NEW_VRORCAMENTODEZ,
									@V_NEW_IDITEMORCAMENTO,
									@V_NEW_CDSERVFILI;


   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_DESC = '';
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_NRANOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'AnoOrc=' + @V_OLD_NRANOORCAOP;
         END;

         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_OLD_CDFILIAL;
         END;

         IF @V_OLD_NRSEQITEMORCA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrSeqItOrc=' + @V_OLD_NRSEQITEMORCA;
         END;

         IF @V_OLD_CDVERSORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdVersao=' + @V_OLD_CDVERSORCAOP;
         END;

         IF @V_OLD_IDENTRSAIDOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntSaiOp=' + @V_OLD_IDENTRSAIDOP;
         END;

         IF @V_OLD_CDTIPOOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdTpOp=' + @V_OLD_CDTIPOOPER;
         END;

         IF @V_OLD_CDDESPADMFAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdDesPadmFat=' + @V_OLD_CDDESPADMFAT;
         END;

         IF @V_OLD_CDDESPPREV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdDesPrev=' + @V_OLD_CDDESPPREV;
         END;

         IF @V_OLD_DTORCAMENTOITEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtOrcItem=' + CONVERT(VARCHAR, @V_OLD_DTORCAMENTOITEM, 103);
         END;

         IF @V_OLD_DTMESBASEITEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtMesBase=' + CONVERT(VARCHAR, @V_OLD_DTMESBASEITEM, 103);
         END;

         IF @V_OLD_IDTIPOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdTpOrcOp=' + @V_OLD_IDTIPOORCAOP;
         END;

         IF @V_OLD_VRORCAMENTOJAN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJan=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOJAN);
         END;

         IF @V_OLD_VRORCAMENTOFEV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcFev=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOFEV);
         END;

         IF @V_OLD_VRORCAMENTOMAR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcMar=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOMAR);
         END;

         IF @V_OLD_VRORCAMENTOABR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcAbr=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOABR);
         END;

         IF @V_OLD_VRORCAMENTOMAI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcMai=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOMAI);
         END;
         
         IF @V_OLD_VRORCAMENTOJUN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJun=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOJUN);
         END;
         
         IF @V_OLD_VRORCAMENTOJUL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJul=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOJUL);
         END;
         
         IF @V_OLD_VRORCAMENTOAGO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcAgo=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOAGO);
         END;
         
         IF @V_OLD_VRORCAMENTOSET IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcSet=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOSET);
         END;
         
         IF @V_OLD_VRORCAMENTOOUT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcOut=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTOOUT);
         END;
         
         IF @V_OLD_VRORCAMENTONOV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcNov=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTONOV);
         END;
         
         IF @V_OLD_VRORCAMENTODEZ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcDez=' + CONVERT(VARCHAR,@V_OLD_VRORCAMENTODEZ);
         END;
         
         IF @V_OLD_IDITEMORCAMENTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdItOrc=' + @V_OLD_IDITEMORCAMENTO;
         END;
         
         IF @V_OLD_CDSERVFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdServ=' + @V_OLD_CDSERVFILI;
         END;
         
         SET @V_TIPO     = '3';
         SET @V_ITPESQ   = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_NRSEQITEMORCA+@V_OLD_CDVERSORCAOP;
      END
      ELSE IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (ISNULL(@V_OLD_NRANOORCAOP ,0)   <> ISNULL(@V_NEW_NRANOORCAOP,0))   OR
            (ISNULL(@V_OLD_CDFILIAL,' ') <> ISNULL(@V_NEW_CDFILIAL,' ')) OR
            (ISNULL(@V_OLD_NRSEQITEMORCA  ,' ') <> ISNULL(@V_NEW_NRSEQITEMORCA ,' ')) OR
            (ISNULL(@V_OLD_CDVERSORCAOP  ,' ') <> ISNULL(@V_NEW_CDVERSORCAOP ,' ')) OR
            (ISNULL(@V_OLD_IDENTRSAIDOP  ,' ') <> ISNULL(@V_NEW_IDENTRSAIDOP ,' ')) OR
            (ISNULL(@V_OLD_CDTIPOOPER  ,' ') <> ISNULL(@V_NEW_CDTIPOOPER ,' ')) OR
            (ISNULL(@V_OLD_CDDESPADMFAT  ,' ') <> ISNULL(@V_NEW_CDDESPADMFAT ,' ')) OR
            (ISNULL(@V_OLD_CDDESPPREV  ,' ') <> ISNULL(@V_NEW_CDDESPPREV ,' ')) OR
            (ISNULL(@V_OLD_DTORCAMENTOITEM  ,' ') <> ISNULL(@V_NEW_DTORCAMENTOITEM ,' ')) OR
            (ISNULL(@V_OLD_DTMESBASEITEM  ,' ') <> ISNULL(@V_NEW_DTMESBASEITEM ,' ')) OR
            (ISNULL(@V_OLD_IDTIPOORCAOP  ,' ') <> ISNULL(@V_NEW_IDTIPOORCAOP ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOJAN  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJAN ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOFEV  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOFEV ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOMAR  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOMAR ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOABR  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOABR ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOMAI  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOMAI ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOJUN  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJUN ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOJUL  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJUL ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOAGO  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOAGO ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOSET  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOSET ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTOOUT  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOOUT ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTONOV  ,' ') <> ISNULL(@V_NEW_VRORCAMENTONOV ,' ')) OR
            (ISNULL(@V_OLD_VRORCAMENTODEZ  ,' ') <> ISNULL(@V_NEW_VRORCAMENTODEZ ,' ')) OR
            (ISNULL(@V_OLD_IDITEMORCAMENTO  ,' ') <> ISNULL(@V_NEW_IDITEMORCAMENTO ,' ')) OR
            (ISNULL(@V_OLD_CDSERVFILI  ,' ') <> ISNULL(@V_NEW_CDSERVFILI ,' ')) BEGIN


            IF (ISNULL(@V_OLD_NRANOORCAOP ,0)   <> ISNULL(@V_NEW_NRANOORCAOP,0))BEGIN
               SET @V_DESC = @V_DESC + 'Ano=' + @V_NEW_NRANOORCAOP;
            END;

            IF (ISNULL(@V_OLD_CDFILIAL,' ') <> ISNULL(@V_NEW_CDFILIAL,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_CDFILIAL;
            END;

            IF (ISNULL(@V_OLD_NRSEQITEMORCA  ,' ') <> ISNULL(@V_NEW_NRSEQITEMORCA ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' NrSeqItOrc=' + @V_NEW_NRSEQITEMORCA;
            END;

            IF (ISNULL(@V_OLD_CDVERSORCAOP  ,' ') <> ISNULL(@V_NEW_CDVERSORCAOP ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdVersao=' + @V_NEW_CDVERSORCAOP;
            END;

            IF (ISNULL(@V_OLD_IDENTRSAIDOP  ,' ') <> ISNULL(@V_NEW_IDENTRSAIDOP ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdEntSaiOp=' + @V_NEW_IDENTRSAIDOP;
            END;

            IF (ISNULL(@V_OLD_CDTIPOOPER  ,' ') <> ISNULL(@V_NEW_CDTIPOOPER ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdTpOper=' + @V_NEW_CDTIPOOPER;
            END;

            IF (ISNULL(@V_OLD_CDDESPADMFAT  ,' ') <> ISNULL(@V_NEW_CDDESPADMFAT ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdDesPadMFat=' + @V_NEW_CDDESPADMFAT;
            END;

            IF (ISNULL(@V_OLD_CDDESPPREV  ,' ') <> ISNULL(@V_NEW_CDDESPPREV ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdDespPrev=' + @V_NEW_CDDESPPREV;
            END;

            IF (ISNULL(@V_OLD_DTORCAMENTOITEM  ,' ') <> ISNULL(@V_NEW_DTORCAMENTOITEM ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' DtOrcItem=' + CONVERT(VARCHAR,@V_NEW_DTORCAMENTOITEM,103);
            END;

            IF (ISNULL(@V_OLD_DTMESBASEITEM  ,' ') <> ISNULL(@V_NEW_DTMESBASEITEM ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' DtMesBaseIt=' + CONVERT(VARCHAR,@V_NEW_DTMESBASEITEM,103);
            END;

            IF (ISNULL(@V_OLD_IDTIPOORCAOP  ,' ') <> ISNULL(@V_NEW_IDTIPOORCAOP ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdTpOrcOp=' + @V_NEW_IDTIPOORCAOP;
            END;

            IF (ISNULL(@V_OLD_VRORCAMENTOJAN  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJAN ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcJan=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJAN);
            END;

            IF (ISNULL(@V_OLD_VRORCAMENTOFEV  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOFEV ,' '))BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcFev=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOFEV);
            END;

            IF (ISNULL(@V_OLD_VRORCAMENTOMAR  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOMAR ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcMar=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOMAR);
            END;

            IF (ISNULL(@V_OLD_VRORCAMENTOABR  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOABR ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcAbr=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOABR);
            END;

            IF (ISNULL(@V_OLD_VRORCAMENTOMAI  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOMAI ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcMai=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOMAI);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTOJUN  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJUN ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcJun=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJUN);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTOJUL  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOJUL ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcJul=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJUL);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTOAGO  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOAGO ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcAgo=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOAGO);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTOSET  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOSET ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcSet=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOSET);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTOOUT  ,' ') <> ISNULL(@V_NEW_VRORCAMENTOOUT ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcOut=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOOUT);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTONOV  ,' ') <> ISNULL(@V_NEW_VRORCAMENTONOV ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' VrOrcNov=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTONOV);
            END;
            
            IF (ISNULL(@V_OLD_VRORCAMENTODEZ  ,' ') <> ISNULL(@V_NEW_VRORCAMENTODEZ ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' vrOrcDez=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTODEZ);
            END;
            
            IF (ISNULL(@V_OLD_IDITEMORCAMENTO  ,' ') <> ISNULL(@V_NEW_IDITEMORCAMENTO ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdItOrc=' + @V_NEW_IDITEMORCAMENTO;
            END;
            
            IF (ISNULL(@V_OLD_CDSERVFILI  ,' ') <> ISNULL(@V_NEW_CDSERVFILI ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdServ=' + @V_NEW_CDSERVFILI;
            END;

            SET @V_TIPO    = '2';
            SET @V_ITPESQ  = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_NRSEQITEMORCA+@V_OLD_CDVERSORCAOP;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO     = '1';
         SET @V_ITPESQ   = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_NRSEQITEMORCA+@V_OLD_CDVERSORCAOP;

         IF @V_NEW_NRANOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'AnoOrc=' + @V_NEW_NRANOORCAOP;
         END;

         IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_CDFILIAL;
         END;

         IF @V_NEW_NRSEQITEMORCA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrSeqItOrc=' + @V_NEW_NRSEQITEMORCA;
         END;

         IF @V_NEW_CDVERSORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdVersao=' + @V_NEW_CDVERSORCAOP;
         END;

         IF @V_NEW_IDENTRSAIDOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntSaiOp=' + @V_NEW_IDENTRSAIDOP;
         END;

         IF @V_NEW_CDTIPOOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdTpOp=' + @V_NEW_CDTIPOOPER;
         END;

         IF @V_NEW_CDDESPADMFAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdDesPadmFat=' + @V_NEW_CDDESPADMFAT;
         END;

         IF @V_NEW_CDDESPPREV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdDesPrev=' + @V_NEW_CDDESPPREV;
         END;

         IF @V_NEW_DTORCAMENTOITEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtOrcItem=' + CONVERT(VARCHAR, @V_NEW_DTORCAMENTOITEM, 103);
         END;

         IF @V_NEW_DTMESBASEITEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtMesBase=' + CONVERT(VARCHAR, @V_NEW_DTMESBASEITEM, 103);
         END;

         IF @V_NEW_IDTIPOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdTpOrcOp=' + @V_NEW_IDTIPOORCAOP;
         END;

         IF @V_NEW_VRORCAMENTOJAN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJan=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJAN);
         END;

         IF @V_NEW_VRORCAMENTOFEV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcFev=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOFEV);
         END;

         IF @V_NEW_VRORCAMENTOMAR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcMar=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOMAR);
         END;

         IF @V_NEW_VRORCAMENTOABR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcAbr=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOABR);
         END;

         IF @V_NEW_VRORCAMENTOMAI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcMai=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOMAI);
         END;
         
         IF @V_NEW_VRORCAMENTOJUN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJun=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJUN);
         END;
         
         IF @V_NEW_VRORCAMENTOJUL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcJul=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOJUL);
         END;
         
         IF @V_NEW_VRORCAMENTOAGO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcAgo=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOAGO);
         END;
         
         IF @V_NEW_VRORCAMENTOSET IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcSet=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOSET);
         END;
         
         IF @V_NEW_VRORCAMENTOOUT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcOut=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTOOUT);
         END;
         
         IF @V_NEW_VRORCAMENTONOV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcNov=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTONOV);
         END;
         
         IF @V_NEW_VRORCAMENTODEZ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrOrcDez=' + CONVERT(VARCHAR,@V_NEW_VRORCAMENTODEZ);
         END;
         
         IF @V_NEW_IDITEMORCAMENTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdItOrc=' + @V_NEW_IDITEMORCAMENTO;
         END;
         
         IF @V_NEW_CDSERVFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdServ=' + @V_NEW_CDSERVFILI;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('ITEMORCAOP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,  @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
									@V_OLD_NRANOORCAOP,
									@V_OLD_CDFILIAL,
									@V_OLD_NRSEQITEMORCA,
									@V_OLD_CDVERSORCAOP,
									@V_OLD_IDENTRSAIDOP,
									@V_OLD_CDTIPOOPER,
									@V_OLD_CDDESPADMFAT,
									@V_OLD_CDDESPPREV,
									@V_OLD_DTORCAMENTOITEM,
									@V_OLD_DTMESBASEITEM,
									@V_OLD_IDTIPOORCAOP,
									@V_OLD_VRORCAMENTOJAN,
									@V_OLD_VRORCAMENTOFEV,
									@V_OLD_VRORCAMENTOMAR,
									@V_OLD_VRORCAMENTOABR,
									@V_OLD_VRORCAMENTOMAI,
									@V_OLD_VRORCAMENTOJUN,
									@V_OLD_VRORCAMENTOJUL,
									@V_OLD_VRORCAMENTOAGO,
									@V_OLD_VRORCAMENTOSET,
									@V_OLD_VRORCAMENTOOUT,
									@V_OLD_VRORCAMENTONOV,
									@V_OLD_VRORCAMENTODEZ,
									@V_OLD_IDITEMORCAMENTO,
									@V_OLD_CDSERVFILI,

									@V_NEW_NRANOORCAOP,
									@V_NEW_CDFILIAL,
									@V_NEW_NRSEQITEMORCA,
									@V_NEW_CDVERSORCAOP,
									@V_NEW_IDENTRSAIDOP,
									@V_NEW_CDTIPOOPER,
									@V_NEW_CDDESPADMFAT,
									@V_NEW_CDDESPPREV,
									@V_NEW_DTORCAMENTOITEM,
									@V_NEW_DTMESBASEITEM,
									@V_NEW_IDTIPOORCAOP,
									@V_NEW_VRORCAMENTOJAN,
									@V_NEW_VRORCAMENTOFEV,
									@V_NEW_VRORCAMENTOMAR,
									@V_NEW_VRORCAMENTOABR,
									@V_NEW_VRORCAMENTOMAI,
									@V_NEW_VRORCAMENTOJUN,
									@V_NEW_VRORCAMENTOJUL,
									@V_NEW_VRORCAMENTOAGO,
									@V_NEW_VRORCAMENTOSET,
									@V_NEW_VRORCAMENTOOUT,
									@V_NEW_VRORCAMENTONOV,
									@V_NEW_VRORCAMENTODEZ,
									@V_NEW_IDITEMORCAMENTO,
									@V_NEW_CDSERVFILI;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GOP_ITEMORCAOP','5.85.000';
GO
